/**
 */
package fsd.impl;

import fsd.ComponentEnd;
import fsd.ComponentHead;
import fsd.FailureComponentEnd;
import fsd.FailureComponentHead;
import fsd.FailureIndicator;
import fsd.FailureNote;
import fsd.FsdPackage;
import fsd.Interaction;
import fsd.MessageComment;
import fsd.MitigationIndicator;
import fsd.MitigationNote;
import fsd.PartComponent;
import fsd.PartComponentFailure;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Interaction</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fsd.impl.InteractionImpl#getFailureindicators <em>Failureindicators</em>}</li>
 *   <li>{@link fsd.impl.InteractionImpl#getComponentHeads <em>Component Heads</em>}</li>
 *   <li>{@link fsd.impl.InteractionImpl#getFailurecomponentEnds <em>Failurecomponent Ends</em>}</li>
 *   <li>{@link fsd.impl.InteractionImpl#getPartComponents <em>Part Components</em>}</li>
 *   <li>{@link fsd.impl.InteractionImpl#getFailurenotes <em>Failurenotes</em>}</li>
 *   <li>{@link fsd.impl.InteractionImpl#getMitigationindicator <em>Mitigationindicator</em>}</li>
 *   <li>{@link fsd.impl.InteractionImpl#getFailurecomponentHeads <em>Failurecomponent Heads</em>}</li>
 *   <li>{@link fsd.impl.InteractionImpl#getPartcomponentfailures <em>Partcomponentfailures</em>}</li>
 *   <li>{@link fsd.impl.InteractionImpl#getMitigationnotes <em>Mitigationnotes</em>}</li>
 *   <li>{@link fsd.impl.InteractionImpl#getMessagecomments <em>Messagecomments</em>}</li>
 *   <li>{@link fsd.impl.InteractionImpl#getComponentEnds <em>Component Ends</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class InteractionImpl extends MinimalEObjectImpl.Container implements Interaction {
	/**
	 * The cached value of the '{@link #getFailureindicators() <em>Failureindicators</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFailureindicators()
	 * @generated
	 * @ordered
	 */
	protected EList<FailureIndicator> failureindicators;

	/**
	 * The cached value of the '{@link #getComponentHeads() <em>Component Heads</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComponentHeads()
	 * @generated
	 * @ordered
	 */
	protected EList<ComponentHead> componentHeads;

	/**
	 * The cached value of the '{@link #getFailurecomponentEnds() <em>Failurecomponent Ends</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFailurecomponentEnds()
	 * @generated
	 * @ordered
	 */
	protected EList<FailureComponentEnd> failurecomponentEnds;

	/**
	 * The cached value of the '{@link #getPartComponents() <em>Part Components</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPartComponents()
	 * @generated
	 * @ordered
	 */
	protected EList<PartComponent> partComponents;

	/**
	 * The cached value of the '{@link #getFailurenotes() <em>Failurenotes</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFailurenotes()
	 * @generated
	 * @ordered
	 */
	protected EList<FailureNote> failurenotes;

	/**
	 * The cached value of the '{@link #getMitigationindicator() <em>Mitigationindicator</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMitigationindicator()
	 * @generated
	 * @ordered
	 */
	protected EList<MitigationIndicator> mitigationindicator;

	/**
	 * The cached value of the '{@link #getFailurecomponentHeads() <em>Failurecomponent Heads</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFailurecomponentHeads()
	 * @generated
	 * @ordered
	 */
	protected EList<FailureComponentHead> failurecomponentHeads;

	/**
	 * The cached value of the '{@link #getPartcomponentfailures() <em>Partcomponentfailures</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPartcomponentfailures()
	 * @generated
	 * @ordered
	 */
	protected EList<PartComponentFailure> partcomponentfailures;

	/**
	 * The cached value of the '{@link #getMitigationnotes() <em>Mitigationnotes</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMitigationnotes()
	 * @generated
	 * @ordered
	 */
	protected EList<MitigationNote> mitigationnotes;

	/**
	 * The cached value of the '{@link #getMessagecomments() <em>Messagecomments</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMessagecomments()
	 * @generated
	 * @ordered
	 */
	protected EList<MessageComment> messagecomments;

	/**
	 * The cached value of the '{@link #getComponentEnds() <em>Component Ends</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComponentEnds()
	 * @generated
	 * @ordered
	 */
	protected EList<ComponentEnd> componentEnds;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InteractionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return FsdPackage.Literals.INTERACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<FailureIndicator> getFailureindicators() {
		if (failureindicators == null) {
			failureindicators = new EObjectContainmentEList<FailureIndicator>(FailureIndicator.class, this, FsdPackage.INTERACTION__FAILUREINDICATORS);
		}
		return failureindicators;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ComponentHead> getComponentHeads() {
		if (componentHeads == null) {
			componentHeads = new EObjectContainmentEList<ComponentHead>(ComponentHead.class, this, FsdPackage.INTERACTION__COMPONENT_HEADS);
		}
		return componentHeads;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<FailureComponentEnd> getFailurecomponentEnds() {
		if (failurecomponentEnds == null) {
			failurecomponentEnds = new EObjectContainmentEList<FailureComponentEnd>(FailureComponentEnd.class, this, FsdPackage.INTERACTION__FAILURECOMPONENT_ENDS);
		}
		return failurecomponentEnds;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ComponentEnd> getComponentEnds() {
		if (componentEnds == null) {
			componentEnds = new EObjectContainmentEList<ComponentEnd>(ComponentEnd.class, this, FsdPackage.INTERACTION__COMPONENT_ENDS);
		}
		return componentEnds;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PartComponent> getPartComponents() {
		if (partComponents == null) {
			partComponents = new EObjectContainmentEList<PartComponent>(PartComponent.class, this, FsdPackage.INTERACTION__PART_COMPONENTS);
		}
		return partComponents;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<FailureNote> getFailurenotes() {
		if (failurenotes == null) {
			failurenotes = new EObjectContainmentEList<FailureNote>(FailureNote.class, this, FsdPackage.INTERACTION__FAILURENOTES);
		}
		return failurenotes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MitigationIndicator> getMitigationindicator() {
		if (mitigationindicator == null) {
			mitigationindicator = new EObjectContainmentEList<MitigationIndicator>(MitigationIndicator.class, this, FsdPackage.INTERACTION__MITIGATIONINDICATOR);
		}
		return mitigationindicator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<FailureComponentHead> getFailurecomponentHeads() {
		if (failurecomponentHeads == null) {
			failurecomponentHeads = new EObjectContainmentEList<FailureComponentHead>(FailureComponentHead.class, this, FsdPackage.INTERACTION__FAILURECOMPONENT_HEADS);
		}
		return failurecomponentHeads;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PartComponentFailure> getPartcomponentfailures() {
		if (partcomponentfailures == null) {
			partcomponentfailures = new EObjectContainmentEList<PartComponentFailure>(PartComponentFailure.class, this, FsdPackage.INTERACTION__PARTCOMPONENTFAILURES);
		}
		return partcomponentfailures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MitigationNote> getMitigationnotes() {
		if (mitigationnotes == null) {
			mitigationnotes = new EObjectContainmentEList<MitigationNote>(MitigationNote.class, this, FsdPackage.INTERACTION__MITIGATIONNOTES);
		}
		return mitigationnotes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MessageComment> getMessagecomments() {
		if (messagecomments == null) {
			messagecomments = new EObjectContainmentEList<MessageComment>(MessageComment.class, this, FsdPackage.INTERACTION__MESSAGECOMMENTS);
		}
		return messagecomments;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case FsdPackage.INTERACTION__FAILUREINDICATORS:
				return ((InternalEList<?>)getFailureindicators()).basicRemove(otherEnd, msgs);
			case FsdPackage.INTERACTION__COMPONENT_HEADS:
				return ((InternalEList<?>)getComponentHeads()).basicRemove(otherEnd, msgs);
			case FsdPackage.INTERACTION__FAILURECOMPONENT_ENDS:
				return ((InternalEList<?>)getFailurecomponentEnds()).basicRemove(otherEnd, msgs);
			case FsdPackage.INTERACTION__PART_COMPONENTS:
				return ((InternalEList<?>)getPartComponents()).basicRemove(otherEnd, msgs);
			case FsdPackage.INTERACTION__FAILURENOTES:
				return ((InternalEList<?>)getFailurenotes()).basicRemove(otherEnd, msgs);
			case FsdPackage.INTERACTION__MITIGATIONINDICATOR:
				return ((InternalEList<?>)getMitigationindicator()).basicRemove(otherEnd, msgs);
			case FsdPackage.INTERACTION__FAILURECOMPONENT_HEADS:
				return ((InternalEList<?>)getFailurecomponentHeads()).basicRemove(otherEnd, msgs);
			case FsdPackage.INTERACTION__PARTCOMPONENTFAILURES:
				return ((InternalEList<?>)getPartcomponentfailures()).basicRemove(otherEnd, msgs);
			case FsdPackage.INTERACTION__MITIGATIONNOTES:
				return ((InternalEList<?>)getMitigationnotes()).basicRemove(otherEnd, msgs);
			case FsdPackage.INTERACTION__MESSAGECOMMENTS:
				return ((InternalEList<?>)getMessagecomments()).basicRemove(otherEnd, msgs);
			case FsdPackage.INTERACTION__COMPONENT_ENDS:
				return ((InternalEList<?>)getComponentEnds()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case FsdPackage.INTERACTION__FAILUREINDICATORS:
				return getFailureindicators();
			case FsdPackage.INTERACTION__COMPONENT_HEADS:
				return getComponentHeads();
			case FsdPackage.INTERACTION__FAILURECOMPONENT_ENDS:
				return getFailurecomponentEnds();
			case FsdPackage.INTERACTION__PART_COMPONENTS:
				return getPartComponents();
			case FsdPackage.INTERACTION__FAILURENOTES:
				return getFailurenotes();
			case FsdPackage.INTERACTION__MITIGATIONINDICATOR:
				return getMitigationindicator();
			case FsdPackage.INTERACTION__FAILURECOMPONENT_HEADS:
				return getFailurecomponentHeads();
			case FsdPackage.INTERACTION__PARTCOMPONENTFAILURES:
				return getPartcomponentfailures();
			case FsdPackage.INTERACTION__MITIGATIONNOTES:
				return getMitigationnotes();
			case FsdPackage.INTERACTION__MESSAGECOMMENTS:
				return getMessagecomments();
			case FsdPackage.INTERACTION__COMPONENT_ENDS:
				return getComponentEnds();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case FsdPackage.INTERACTION__FAILUREINDICATORS:
				getFailureindicators().clear();
				getFailureindicators().addAll((Collection<? extends FailureIndicator>)newValue);
				return;
			case FsdPackage.INTERACTION__COMPONENT_HEADS:
				getComponentHeads().clear();
				getComponentHeads().addAll((Collection<? extends ComponentHead>)newValue);
				return;
			case FsdPackage.INTERACTION__FAILURECOMPONENT_ENDS:
				getFailurecomponentEnds().clear();
				getFailurecomponentEnds().addAll((Collection<? extends FailureComponentEnd>)newValue);
				return;
			case FsdPackage.INTERACTION__PART_COMPONENTS:
				getPartComponents().clear();
				getPartComponents().addAll((Collection<? extends PartComponent>)newValue);
				return;
			case FsdPackage.INTERACTION__FAILURENOTES:
				getFailurenotes().clear();
				getFailurenotes().addAll((Collection<? extends FailureNote>)newValue);
				return;
			case FsdPackage.INTERACTION__MITIGATIONINDICATOR:
				getMitigationindicator().clear();
				getMitigationindicator().addAll((Collection<? extends MitigationIndicator>)newValue);
				return;
			case FsdPackage.INTERACTION__FAILURECOMPONENT_HEADS:
				getFailurecomponentHeads().clear();
				getFailurecomponentHeads().addAll((Collection<? extends FailureComponentHead>)newValue);
				return;
			case FsdPackage.INTERACTION__PARTCOMPONENTFAILURES:
				getPartcomponentfailures().clear();
				getPartcomponentfailures().addAll((Collection<? extends PartComponentFailure>)newValue);
				return;
			case FsdPackage.INTERACTION__MITIGATIONNOTES:
				getMitigationnotes().clear();
				getMitigationnotes().addAll((Collection<? extends MitigationNote>)newValue);
				return;
			case FsdPackage.INTERACTION__MESSAGECOMMENTS:
				getMessagecomments().clear();
				getMessagecomments().addAll((Collection<? extends MessageComment>)newValue);
				return;
			case FsdPackage.INTERACTION__COMPONENT_ENDS:
				getComponentEnds().clear();
				getComponentEnds().addAll((Collection<? extends ComponentEnd>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case FsdPackage.INTERACTION__FAILUREINDICATORS:
				getFailureindicators().clear();
				return;
			case FsdPackage.INTERACTION__COMPONENT_HEADS:
				getComponentHeads().clear();
				return;
			case FsdPackage.INTERACTION__FAILURECOMPONENT_ENDS:
				getFailurecomponentEnds().clear();
				return;
			case FsdPackage.INTERACTION__PART_COMPONENTS:
				getPartComponents().clear();
				return;
			case FsdPackage.INTERACTION__FAILURENOTES:
				getFailurenotes().clear();
				return;
			case FsdPackage.INTERACTION__MITIGATIONINDICATOR:
				getMitigationindicator().clear();
				return;
			case FsdPackage.INTERACTION__FAILURECOMPONENT_HEADS:
				getFailurecomponentHeads().clear();
				return;
			case FsdPackage.INTERACTION__PARTCOMPONENTFAILURES:
				getPartcomponentfailures().clear();
				return;
			case FsdPackage.INTERACTION__MITIGATIONNOTES:
				getMitigationnotes().clear();
				return;
			case FsdPackage.INTERACTION__MESSAGECOMMENTS:
				getMessagecomments().clear();
				return;
			case FsdPackage.INTERACTION__COMPONENT_ENDS:
				getComponentEnds().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case FsdPackage.INTERACTION__FAILUREINDICATORS:
				return failureindicators != null && !failureindicators.isEmpty();
			case FsdPackage.INTERACTION__COMPONENT_HEADS:
				return componentHeads != null && !componentHeads.isEmpty();
			case FsdPackage.INTERACTION__FAILURECOMPONENT_ENDS:
				return failurecomponentEnds != null && !failurecomponentEnds.isEmpty();
			case FsdPackage.INTERACTION__PART_COMPONENTS:
				return partComponents != null && !partComponents.isEmpty();
			case FsdPackage.INTERACTION__FAILURENOTES:
				return failurenotes != null && !failurenotes.isEmpty();
			case FsdPackage.INTERACTION__MITIGATIONINDICATOR:
				return mitigationindicator != null && !mitigationindicator.isEmpty();
			case FsdPackage.INTERACTION__FAILURECOMPONENT_HEADS:
				return failurecomponentHeads != null && !failurecomponentHeads.isEmpty();
			case FsdPackage.INTERACTION__PARTCOMPONENTFAILURES:
				return partcomponentfailures != null && !partcomponentfailures.isEmpty();
			case FsdPackage.INTERACTION__MITIGATIONNOTES:
				return mitigationnotes != null && !mitigationnotes.isEmpty();
			case FsdPackage.INTERACTION__MESSAGECOMMENTS:
				return messagecomments != null && !messagecomments.isEmpty();
			case FsdPackage.INTERACTION__COMPONENT_ENDS:
				return componentEnds != null && !componentEnds.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //InteractionImpl
